---
title: NodeIterator.whatToShow
slug: Web/API/NodeIterator/whatToShow
tags:
  - API
  - DOM
  - NodeIterator
  - Property
---
<div>{{APIRef("DOM")}}</div>

<p>The <strong><code>NodeIterator.whatToShow</code></strong> read-only property represents an <code>unsigned integer</code> representing a bitmask signifying what types of nodes should be returned by the {{domxref("NodeIterator")}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var nodeTypes = <em>nodeIterator</em>.whatToShow;
</pre>

<p>The values that can be combined to form the bitmask are:</p>

<table class="standard-table">
	<tbody>
		<tr>
			<td class="header">Constant</td>
			<td class="header">Numerical value</td>
			<td class="header">Description</td>
		</tr>
		<tr>
			<td><code>NodeFilter.SHOW_ALL</code></td>
			<td><code>-1</code> (that is the max value of <code>unsigned long</code>)</td>
			<td>Shows all nodes.</td>
		</tr>
		<tr>
			<td><code>NodeFilter.SHOW_ATTRIBUTE</code> {{deprecated_inline}}</td>
			<td><code>2</code></td>
			<td>Shows attribute {{ domxref("Attr") }} nodes. This is meaningful only when creating a {{ domxref("NodeIterator") }} or {{ domxref("TreeWalker") }} with an {{ domxref("Attr") }} node as its root; in this case, it means that the attribute node will appear in the first position of the iteration or traversal. Since attributes are never children of other nodes, they do not appear when traversing over the document tree.</td>
		</tr>
		<tr>
			<td><code>NodeFilter.SHOW_CDATA_SECTION</code> {{deprecated_inline}}</td>
			<td><code>8</code></td>
			<td>Shows {{ domxref("CDATASection") }} nodes.</td>
		</tr>
		<tr>
			<td><code>NodeFilter.SHOW_COMMENT</code></td>
			<td><code>128</code></td>
			<td>Shows {{ domxref("Comment") }} nodes.</td>
		</tr>
		<tr>
			<td><code>NodeFilter.SHOW_DOCUMENT</code></td>
			<td><code>256</code></td>
			<td>Shows {{ domxref("Document") }} nodes.</td>
		</tr>
		<tr>
			<td><code>NodeFilter.SHOW_DOCUMENT_FRAGMENT</code></td>
			<td><code>1024</code></td>
			<td>Shows {{ domxref("DocumentFragment") }} nodes.</td>
		</tr>
		<tr>
			<td><code>NodeFilter.SHOW_DOCUMENT_TYPE</code></td>
			<td><code>512</code></td>
			<td>Shows {{ domxref("DocumentType") }} nodes.</td>
		</tr>
		<tr>
			<td><code>NodeFilter.SHOW_ELEMENT</code></td>
			<td><code>1</code></td>
			<td>Shows {{ domxref("Element") }} nodes.</td>
		</tr>
		<tr>
			<td><code>NodeFilter.SHOW_ENTITY</code> {{deprecated_inline}}</td>
			<td><code>32</code></td>
			<td>Shows {{ domxref("Entity") }} nodes. This is meaningful only when creating a {{ domxref("NodeIterator") }} or {{ domxref("TreeWalker") }} with an {{ domxref("Entity") }} node as its root; in this case, it means that the {{ domxref("Entity") }} node will appear in the first position of the traversal. Since entities are not part of the document tree, they do not appear when traversing over the document tree.</td>
		</tr>
		<tr>
			<td><code>NodeFilter.SHOW_ENTITY_REFERENCE</code> {{deprecated_inline}}</td>
			<td><code>16</code></td>
			<td>Shows {{ domxref("EntityReference") }} nodes.</td>
		</tr>
		<tr>
			<td><code>NodeFilter.SHOW_NOTATION</code> {{deprecated_inline}}</td>
			<td><code>2048</code></td>
			<td>Shows {{ domxref("Notation") }} nodes. This is meaningful only when creating a {{ domxref("NodeIterator") }} or {{ domxref("TreeWalker") }} with a {{ domxref("Notation") }} node as its root; in this case, it means that the {{ domxref("Notation") }} node will appear in the first position of the traversal. Since entities are not part of the document tree, they do not appear when traversing over the document tree.</td>
		</tr>
		<tr>
			<td><code>NodeFilter.SHOW_PROCESSING_INSTRUCTION</code></td>
			<td><code>64</code></td>
			<td>Shows {{ domxref("ProcessingInstruction") }} nodes.</td>
		</tr>
		<tr>
			<td><code>NodeFilter.SHOW_TEXT</code></td>
			<td><code>4</code></td>
			<td>Shows {{ domxref("Text") }} nodes.</td>
		</tr>
	</tbody>
</table>

<h2 id="Example">Example</h2>

<pre class="brush: js">var nodeIterator = document.createNodeIterator(
    document.body,
    NodeFilter.SHOW_ELEMENT + NodeFilter.SHOW_COMMENT + NodeFilter.SHOW_TEXT,
    { acceptNode: function(node) { return NodeFilter.FILTER_ACCEPT; } },
    false
);
if( (nodeIterator.whatToShow == NodeFilter.SHOW_ALL) ||
    (nodeIterator.whatToShow % (NodeFilter.SHOW_COMMENT*2)) &gt;= NodeFilter.SHOW_COMMENT) {
    // nodeIterator will show comments
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('DOM WHATWG', '#dom-nodeiterator-whattoshow', 'NodeIterator.whatToShow')}}</td>
			<td>{{Spec2('DOM WHATWG')}}</td>
			<td>No change from {{SpecName('DOM2 Traversal_Range')}}.</td>
		</tr>
		<tr>
			<td>{{SpecName('DOM2 Traversal_Range', 'traversal.html#Traversal-NodeIterator-whatToShow', 'NodeIterator.whatToShow')}}</td>
			<td>{{Spec2('DOM2 Traversal_Range')}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.NodeIterator.whatToShow")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>The interface this property belongs to: {{domxref("NodeIterator")}}.</li>
</ul>
